﻿namespace Infrastructure.EventBus;

public interface IEventBus
{
    void Publish(IntegrationEvent integrationEvent);

    void Subscribe<T, TH>() where T : IntegrationEvent where TH : IIntegrationEventHandler<T>;

    void Unsubscribe<T, TH>() where TH : IIntegrationEventHandler<T> where T : IntegrationEvent;

    void SubscribeDynamic<TH>(string eventName) where TH : IDynamicIntegrationEventHandler;

    void UnsubscribeDynamic<TH>(string eventName) where TH : IDynamicIntegrationEventHandler;
}